import { extractScriptTags, readFileFromUrl, getAstroHtmls, stripScriptTags, transpileScriptBody, injectTranspiledScripts, writeFileToUrl, } from "../utils/index.js";
const hook = (options, outDir) => {
    const HTMLURLs = getAstroHtmls(outDir);
    HTMLURLs.forEach((HTMLURL) => {
        const transformOptions = options;
        const fileContent = readFileFromUrl(HTMLURL);
        if (HTMLURL.endsWith(".html")) {
            const scriptsBodies = [];
            const transpiledScriptsBodies = [];
            const scripts = extractScriptTags(fileContent);
            if (!scripts) {
                return;
            }
            scripts.forEach((script) => {
                const scriptBody = stripScriptTags(script);
                const transpiledScript = transpileScriptBody(scriptBody, transformOptions);
                if (!transpiledScript) {
                    return;
                }
                scriptsBodies.push(scriptBody);
                transpiledScriptsBodies.push(transpiledScript);
            });
            const injectedFileContent = injectTranspiledScripts(fileContent, scriptsBodies, transpiledScriptsBodies);
            writeFileToUrl(injectedFileContent, HTMLURL);
        }else{
            const transpiledScript = transpileScriptBody(fileContent, transformOptions);
            writeFileToUrl(transpiledScript, HTMLURL);
        }

    });
};
export default hook;
